<template>
  <v-card class="contenedor">
    <v-app-bar class="nav-deg" dark flat v-if="printStatus == false">
      <v-app-bar-nav-icon @click.stop="drawer = !drawer"></v-app-bar-nav-icon>

      <v-toolbar-title>SECAP</v-toolbar-title>

      <v-spacer></v-spacer>
      <div v-if="loggedIn == false">
        <v-btn @click="dialog = !dialog" class="ma-2" outlined color="white"
          >Iniciar sesion</v-btn
        >
      </div>
      <div v-if="loggedIn == true">
        <v-btn @click="signOut" class="ma-2" outlined color="white"
          >Cerrar sesion</v-btn
        >
      </div>
    </v-app-bar>
    <v-navigation-drawer
      class="nav-deg"
      dark
      v-model="drawer"
      absolute
      temporary
      v-if="loggedIn==true"
    >

      <v-divider></v-divider>

      <v-list dense v-if="role == 'Administrador'">
        <v-list-item v-for="nav_item in admin_items" :key="nav_item.title" link>
          <v-list-item-icon @click="changeview(nav_item.value)">
            <v-icon>mdi-{{ nav_item.icon }}</v-icon>
          </v-list-item-icon>

          <v-list-item-content @click="changeview(nav_item.value)">
            <v-list-item-title>{{ nav_item.title }}</v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list>

      <v-list dense v-if="role == 'Agente'">
        <v-list-item v-for="nav_item in agent_items" :key="nav_item.title" link>
          <v-list-item-icon @click="changeview(nav_item.value)">
            <v-icon>mdi-{{ nav_item.icon }}</v-icon>
          </v-list-item-icon>

          <v-list-item-content @click="changeview(nav_item.value)">
            <v-list-item-title>{{ nav_item.title }}</v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list>

    </v-navigation-drawer>
    <v-dialog class="dialog" v-model="dialog" max-width="800px" max-height="600px">
      <div class="contenedor-login">
      <v-img src="../assets/mercadito.png" aspect-ratio="1.0" class="imagen-login"></v-img>
        <v-row justify="center">
          <v-col cols="12" sm="10" md="8" lg="6">
            <v-card ref="form">
              <v-card-text>
                <v-text-field
                  ref="email"
                  v-model="email_login"
                  label="Correo Electronico"
                  placeholder="Correo"
                  counter="25"
                  required
                ></v-text-field>
                <v-text-field
                  v-model="password_login"
                  type="password"
                  label="Contraseña"
                  hint="Tu contraseña cumple con los 8 caracteres"
                  counter
                  @click:append="show1 = !show1"
                ></v-text-field>
                 <v-img src="../assets/logoEscucha.png" aspect-ratio="3.0" class="logo-escucha"></v-img>
              </v-card-text>
              <v-divider class="mt-12"></v-divider>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="primary" text @click="logIn">Login </v-btn>
              </v-card-actions>
            </v-card>
          </v-col>
        </v-row>
      </div>
    </v-dialog>
    <v-dialog v-model="dialog2" max-width="500px">
      <v-card>
        <v-card-title>
          <span class="headline">Registro de usuarios</span>
        </v-card-title>
        <v-card-text>
          <v-text-field
            v-for="user in user_data"
            :key="user.title"
            type="text"
            :placeholder="user.title"
            v-model="user.value"
          >
          </v-text-field>
          <v-text-field type="password" v-model="user_password"> </v-text-field>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn dark color="red" @click="dialog2 = !dialog2">Cancelar</v-btn>
          <v-btn dark color="#8CC63F" @click.prevent="signUp">Acceder</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <div v-if="view == 0">
      <Home/>
    </div>
    <div v-if="view == 1">
      <ListaProductosAdmin />
    </div>
    <div v-if="view == 2">
      <ListaPaquetesAdmin />
    </div>
    <div v-if="view == 3">
      <PedidosGerente />
    </div>
    <div v-if="view == 4">
      <GestionPedidos />
    </div>
    <div v-if="view == 5">
      <Pedidos v-if="printStatus == false" @printOrder="printOrder" />
      <ImprimirTicket
        v-if="printStatus == true"
        @printOrder="printOrder"
        :printContent="printContent"
      />
    </div>
    <div v-if="view == 6">
      <LoginAdminRegistro />
    </div>
  </v-card>
</template>

<script>
import "firebase/auth";
import firebase from "firebase/app";
import "firebase/firestore";
import ListaProductosAdmin from "./ListaProductosAdmin";
import ListaPaquetesAdmin from "./ListaPaquetesAdmin";
import GestionPedidos from "./GestionPedidos";
//import CrearPaquete from './CrearPaquete';
import PedidosGerente from "./PedidosGerente";
import Pedidos from "./Pedidos";
import ImprimirTicket from "./ImprimirTicket";
import LoginAdminRegistro from "./LoginAdminRegistro";
import Home from './Home'

export default {
  async created() {
    firebase.auth().onAuthStateChanged(async (user) => {
      this.loggedIn = !!user;
      const claims = await firebase.auth().currentUser.getIdTokenResult()
      const role = claims.claims.role
      this.role = role
      console.log(this.role)
      const userData = await this.$axios.get(
        `http://${process.env.VUE_APP_API_URL}/api/users/${user.uid}`
      );
      this.user = userData.data;
    });
  },
  components: {
    ListaProductosAdmin,
    ListaPaquetesAdmin,
    GestionPedidos,
    //CrearPaquete,
    PedidosGerente,
    Pedidos,
    ImprimirTicket,
    LoginAdminRegistro,
    Home
  },
  data() {
    return {
      loggedIn: false,
      user: "",
      email: "",
      role:null,
      email_login:null,
      password_login:null,
      password: "",
      error: "",
      view: 0,
      user_data: [
        { title: "Nombre", value: null },
        { title: "Apellidos", value: null },
        { title: "Calle", value: null },
        { title: "Colonia", value: null },
        { title: "Código Postal", value: null },
        { title: "Celular", value: null },
        { title: "Correo electrónico", value: null },
        //{ title: 'Entre calles', value:null},
        //{ title: 'Observaciones y descripción del domicilio', value:null},
        //{ title: 'Telefono particular', value:null},
      ],
      user_password: null,
      dialog: false,
      dialog2: false,
      drawer: null,
      printStatus: false,
      printContent: {},
      admin_items:[
        {
          title: "Productos",
          icon: "order-bool-ascending-variant",
          value: "1",
        },
        { title: "Paquetes", icon: "order-bool-ascending-variant", value: "2" },
        {
          title: "Nuevo Paquete",
          icon: "order-bool-ascending-variant",
          value: "3",
        },
        {
          title: "Pedidos Administrador",
          icon: "order-bool-ascending-variant",
          value: "4",
        },
        { title: "Registro", icon: "order-bool-ascending-variant", value: "6" },
      ],
      agent_items:[
        { title: "Pedidos", icon: "order-bool-ascending-variant", value: "5" },
      ]
    };
  },

  methods: {
    printOrder(status, content) {
      this.printStatus = status;
      this.printContent = content;
    },
    changeview(value) {
      this.view = value;
      this.drawer = false;
    },
    async logIn() {
      firebase
        .auth()
        .signInWithEmailAndPassword(this.email_login, this.password_login)
        .then(() => {
          this.dialog = false;
          this.email = null;
          this.password = null;
        })
        .catch((error) => {
          this.error = error;
        });
    },
    async signUp() {
      let db = firebase.firestore();
      let email = this.user_data[6].value;
      let pass = this.user_password;
      let userData = {
        name: this.user_data[0].value,
        last_name: this.user_data[1].value,
        street: this.user_data[2].value,
        bloc: this.user_data[3].value,
        postal_code: this.user_data[4].value,
        phone: this.user_data[5].value,
        email: email,
      };
      firebase
        .auth()
        .createUserWithEmailAndPassword(email, pass)
        .then((credentials) => {
          return db
            .collection("users")
            .doc(credentials.user.uid)
            .set(userData);
        })
        .then(() => {
          console.log("Usuario creado");
        });
    },
    async signOut() {
      try {
        await firebase.auth().signOut();
        window.location.reload()
      } catch (error) {
        console.log(error);
      }
    },
  },
};
</script>

<style scoped>
.contenedor {
  background-color: #FAFAFA;
  height: 100%;
}
.nav-deg{
  background: linear-gradient(70deg, #572B53, #0B2748);
}
.dialog{
  background: linear-gradient(70deg, #572B53, #0B2748);
  height: 15rem;
}
.contenedor-login {
  background: linear-gradient(70deg, #572B53, #0B2748);
  height: 50%;
  margin: 1%;
}
.imagen-login{
  display:block;
  margin:auto;
  width:100%;
  max-width:200px;
}
.logo-escucha{
  display:block;
  margin:auto;
  width:100%;
  max-width:200px;
}
.boton-login{
  background-color: #414142;
  color: white;
}
</style>
